import uno
import os
import pandas as pd
import numpy as np
import subprocess
import locale
import colorsys
import shutil

locale.setlocale(locale.LC_ALL, '')
LongueurMaxString = 20


def rgb2int(r, g, b):
    return (256**2) * int(r, 16) + 256*int(g, 16) + int(b, 16)


def Initialization():
    oDoc = XSCRIPTCONTEXT.getDocument()
    MonPath = os.path.dirname(oDoc.getURL().replace('file://', ''))
    os.chdir(MonPath)
    ContextPath = "/home/parents/Documents/11-informatique/11.30-app_context-linux-64/tex/texmf-linux-64/bin/"
    return (oDoc, MonPath, ContextPath)


def TraiterOnglet(oDoc, NomOnglet, ListeATraiter, MonPath, FichierSortie):

    MaSheet = oDoc.getSheets().getByName(NomOnglet)

    TexteSortie = ""

    for NamedRange, RangeType in ListeATraiter:

        TexteSortie = TexteSortie + \
            TraiteZoneType(MaSheet.getCellRangeByName(NamedRange), RangeType)

    with open(MonPath + '/' + FichierSortie, 'w') as f:
        f.write(TexteSortie + '\n')
    f.close()


def TraiteZoneType(Zone, TypeZone):

    # TypeZone A : \fonction [col1] [x=…,y=…]   en itérant sur les colonnes
    # TypeZone B : \fonction [col0] [col1]
    # TypeZone C : \fonction        [x=…,y=…]   en itérant sur les lignes pour x,y,… (mais aussi les colonnes mais que une...)
    # TypeZone D : \fonction [colk] [x=…,y=…] … en itérant sur les lignes pour x,y,… ET sur les colonnes pour colk
    # TypeZone E : \fonctionk                   en itérant sur les lignes pour fonctionk

    MaData = ChargeZone(Zone)
    NomColonnes = MaData.columns.values.tolist()

    TexteSortie = "\n"

    # ------------------------------------------------------------------

    if TypeZone == 'A' or TypeZone == 'B' or TypeZone == 'E':

        MaData[NomColonnes[1]] = MaData[NomColonnes[1]].replace('', np.nan)
        MaData = MaData.dropna(subset=[NomColonnes[1]])

        for index, row in MaData.iterrows():

            if TypeZone == 'A' or TypeZone == 'B':
                TexteSortie = TexteSortie + str(NomColonnes[0])

    # ------------------------------------------------------------------
            if TypeZone == 'A':

                TexteSortie = \
                    TexteSortie + " [" + \
                    (str(row[NomColonnes[1]]) + "]") \
                    .ljust(LongueurMaxString) + "["

                for j in range(len(row)-2):
                    NomColonne = NomColonnes[j+2]
                    TexteSortie = TexteSortie + \
                        str(NomColonne) + "=" + str(row[NomColonne])

                    if j < len(row)-3:
                        TexteSortie = TexteSortie + ","
                    else:
                        TexteSortie = TexteSortie + "]"

    # ------------------------------------------------------------------
            if TypeZone == 'B':

                TexteSortie = TexteSortie + " [" + \
                    (str(row[NomColonnes[0]]) + "]")\
                    .ljust(LongueurMaxString) + \
                    "[" + str(row[NomColonnes[1]]) + "]"

    # ------------------------------------------------------------------
            if TypeZone == 'E':

                if row[NomColonnes[1]] == "yes":

                    TexteSortie = TexteSortie + str(row[NomColonnes[0]])

    # ------------------------------------------------------------------

            TexteSortie = TexteSortie + "\n"

# ------------------------------------------------------------------

    if TypeZone == 'C' or TypeZone == 'D':

        for i in range(MaData.shape[1]-1):

            TexteSortie = TexteSortie + \
                str(NomColonnes[0]) + "\n"

            if TypeZone == 'D':
                TexteSortie = TexteSortie + \
                    "  [" + str(NomColonnes[i+1]) + "]\n"

            TexteSortie = TexteSortie + "  [\n"

            for j in range(MaData.shape[0]):

                if str(MaData.iloc[j, i+1]) != "":
                    TexteSortie = TexteSortie + \
                        "   " + str(MaData.iloc[j, 0]) + "=" +\
                        str(MaData.iloc[j, i+1]) + ",\n"

            TexteSortie = TexteSortie + "  ]\n\n"

# ------------------------------------------------------------------

    if TypeZone == 'F_Fonts':

        # on itére selon les lignes. puis selon les colonnes

        for i in range(MaData.shape[0]):

            MonType = str(MaData.iloc[i, 0])
            TexteSortie = TexteSortie + str(NomColonnes[0])
            TexteSortie = TexteSortie + " [" + MonType + "] [myfont]\n"
            TexteSortie = TexteSortie + "\\setups[font:fallback:type]".replace("type", MonType) + "\n"

            for j in range(MaData.shape[1]-1):
                TexteSortie = TexteSortie + "  \\definefontsynonym [" + MonType.capitalize()
                if str(NomColonnes[j+1]) != "Regular":
                    TexteSortie = TexteSortie + (str(NomColonnes[j+1])+"]").ljust(30)
                else:
                    TexteSortie = TexteSortie + "]".ljust(30)

                TexteSortie = TexteSortie + "[name:" + (str(MaData.iloc[i, j+1])+"]").ljust(30) + \
                    "[features=default]\n"

            TexteSortie = TexteSortie + str(NomColonnes[0]).replace("start", "stop") + "\n\n"

        TexteSortie = TexteSortie + \
            "\\starttypescript[myfont]\n" +\
            "\\definetypeface [myfont] [rm] [serif]       [myfont] [default]\n" +\
            "\\definetypeface [myfont] [ss] [sans]        [myfont] [default]\n" +\
            "\\definetypeface [myfont] [tt] [mono]        [myfont] [default]\n" +\
            "\\definetypeface [myfont] [mm] [math]        [myfont] [default]\n" +\
            "\\definetypeface [myfont] [hm] [handwriting] [myfont] [default]\n" +\
            "\\definetypeface [myfont] [cg] [calligraphy] [myfont] [default]\n" +\
            "\\stoptypescript\n\n"

# ------------------------------------------------------------------

    TexteSortie = TexteSortie + "\n"

    return TexteSortie


def ChargeZone(Zone):

    MaData = pd.DataFrame(Zone.getDataArray())

    MaData.columns = MaData.iloc[0]
    MaData = MaData[1:]

    return MaData


def Colorier(MaSheet, NomTable):

    # pas robuste car getCellByPosition en dur,
    # indépendantes de la position du range

    MaZone = MaSheet.getCellRangeByName(NomTable)
    NombreCouleur = MaZone.Rows.Count - 1
    StartCouleur = MaZone.RangeAddress.StartRow + 1

    for iCouleur in range(NombreCouleur):

        if MaSheet.getCellByPosition(2, StartCouleur+iCouleur).String != "":

            MaSheet.getCellByPosition(1, StartCouleur+iCouleur).String = \
                str(MaSheet.getCellByPosition(3, StartCouleur+iCouleur).Value)

            rgb = colorsys.hsv_to_rgb(
                MaSheet.getCellByPosition(3, StartCouleur+iCouleur).Value/360.,
                MaSheet.getCellByPosition(4, StartCouleur+iCouleur).Value,
                MaSheet.getCellByPosition(5, StartCouleur+iCouleur).Value)

            rgb = (hex(round(rgb[0]*255)),
                   hex(round(rgb[1]*255)),
                   hex(round(rgb[2]*255)))
            monentier = rgb2int(rgb[0], rgb[1], rgb[2])
            MaSheet.getCellByPosition(1, StartCouleur+iCouleur).String = ""
            MaSheet.getCellByPosition(1,
                StartCouleur+iCouleur).CellBackColor = monentier

        else:
            MaSheet.getCellByPosition(1,
                StartCouleur+iCouleur).String = ""
            MaSheet.getCellByPosition(1,
                StartCouleur+iCouleur).CellBackColor = 14606562


def UpdateFontsDatabase(args=None):
    # "récupérer la liste des fopnts et leur x height"
    # mettre un bouton dédié
    # mettre en liste à choix, de façon itérative

    (oDoc, MonPath, ContextPath) = Initialization()

# Récupération de la liste avec mtxrun --------------------------------



    processA = subprocess.Popen(ContextPath +
                                "mtxrun --script font --list --all > " +
                                MonPath + "/liste_fonts.csv",
                                stdout=subprocess.PIPE,
                                shell=True, encoding='utf8')
    try:
        print('Running in process', processA.pid)
        processA.wait(timeout=100)
    except processA.TimeoutExpired:
        print('Timed out - killing', processA.pid)
        processA.kill()
    print("Done")

#    dffonts = pd.read_fwf(MonPath + "/liste_fonts.csv", widths=[58, 35, 49, 200])
    dffonts = pd.read_fwf(MonPath + "/liste_fonts.csv")


#    os.remove(MonPath + "/liste_fonts.csv")

#    dffonts.to_csv('test.csv')
    dffonts = dffonts.sort_values(by=['familyname', 'fontname'],)

#  import pandas as pd
#  dffonts = pd.read_fwf("/home/parents/Drive/05_programmation/interface_context/liste_fonts.csv")


# # On affiche les familyname dans un onglet FontsDB ------------------------

    MaSheet = oDoc.getSheets().getByName("FontsDB")

    baseSelect = "familyname"  # vs "identifier"

    dffontsfamilies = dffonts[[baseSelect]].drop_duplicates()
    dffontnames = dffonts[["identifier", "familyname", "fontname"]]

    MonTestB = dffontsfamilies.to_records(index=False).tolist()

    start_column = 1
    start_rowB = 2
    end_column = start_column + dffontsfamilies.shape[1] - 1
    end_rowB = start_rowB + dffontsfamilies.shape[0] - 1

    MaSheet.Rows.removeByIndex(2, 10000)
    MaRange = MaSheet.getCellRangeByPosition(start_column, start_rowB, end_column, end_rowB)
    MaRange.setDataArray(MonTestB)
    oDoc.DatabaseRanges.addNewByName("TableFontsDatabase", MaRange.RangeAddress)


# On utilise les familyname en liste selection dans onglet FontsDB ------------

    MaSheet = oDoc.getSheets().getByName("Fonts")

    MaRange2 = MaSheet.getCellRangeByName("TableFonts")
    MaRange2Add = MaRange2.getRangeAddress()

    MaRange3 = MaSheet.getCellRangeByPosition(MaRange2Add.StartColumn-1,
                                              MaRange2Add.StartRow+1,
                                              MaRange2Add.StartColumn-1,
                                              MaRange2Add.EndRow)

    oValidation = MaRange3.Validation
    oValidation.Type = "LIST"
    oValidation.setFormula1("TableFontsDatabase")
    MaRange3.Validation = oValidation

# On utilise les fontname  en liste selection à partir du familyname ------------

    for i in range(MaRange2.Rows.Count-1):

        familynameVal = MaSheet.getCellByPosition(MaRange2Add.StartColumn-1,
                                                  MaRange2Add.StartRow+1+i).String

        MaRange4 = MaSheet.getCellRangeByPosition(MaRange2Add.StartColumn+1,
                                                  MaRange2Add.StartRow+1+i,
                                                  MaRange2Add.EndColumn,
                                                  MaRange2Add.StartRow+1+i)

#       faut efface, mettre les filtres, remettre les valeurs ....
        oDataSource = MaRange4.getDataArray()

        for j in range(MaRange2.Columns.Count-1):
            Tmp = MaSheet.getCellByPosition(MaRange2Add.StartColumn+1+j,
                                           MaRange2Add.StartRow+1+i)
            Tmp.String = ""
            oValidation = Tmp.Validation
            oValidation.Type = 0
            Tmp.Validation = oValidation

        fontnameList = dffontnames[dffontnames[baseSelect].str.contains(familynameVal)]
        fontnameList = fontnameList.drop_duplicates(subset=['fontname'])
        maliste = ";".join(fontnameList["fontname"].tolist())

        # fontnameList.to_csv("test" + str(i) + ".csv")

        # with open(r"test" + str(i) + ".txt", 'w') as fp:
        #     for item in fontnameList["fontname"].tolist():
        #         # write each item on a new line
        #         fp.write("%s\n" % item)
        #     print('Done')

        oValidation = MaRange4.Validation

#        oValidation.Type = 0
#        MaRange4.Validation = oValidation

        oValidation.Type = 6   # "LIST"
#        oValidation.Type = "LIST"
#        oValidation.setOperator(1)
        oValidation.setFormula1(maliste)
        MaRange4.Validation = oValidation

        MaRange4.setDataArray(oDataSource)


def WriteAndContext(args=None):

    (oDoc, MonPath, ContextPath) = Initialization()

    FichierTex = 'readme.tex'

# COLORS -----------------------------------------------------------

    ListeCouleurs = [["TableCouleurs", 'A'],
                     ["TableCouleursGeneriques", 'B'],
                     ["TableCouleursSetup", 'C']]

    TraiterOnglet(oDoc, "Colors", ListeCouleurs,
                  MonPath, 'env_A05_color.tex')

    Colorier(oDoc.getSheets().getByName("Colors"), "TableCouleurs")


# SECTIONNING ---------------------------------------------------------

    ListeSections = [["TableSections", 'D']]

    TraiterOnglet(oDoc, "Sections", ListeSections,
                  MonPath, 'env_B14_section.tex')

# LAYOUT --------------------------------------------------------------

    ListeLayout = [["TableLayout", 'C'],
                   ["TableLayoutOptions", 'E']]

    TraiterOnglet(oDoc, "Layout", ListeLayout,
                  MonPath, 'env_A01_layout.tex')

# FONT --------------------------------------------------------------

    ListeFont = [["TableFonts", 'F_Fonts'],
                 ["TableFontsOptions", 'E']]

    TraiterOnglet(oDoc, "Fonts", ListeFont,
                  MonPath, 'env_A04_fonts.tex')

# ------------------------------------------------------------------

    processB = subprocess.Popen([ContextPath + "context", '--batchmode', FichierTex])
    try:
        print('Running in process', processB.pid)
        processB.wait(timeout=30)
    except processB.TimeoutExpired:
        print('Timed out - killing', processB.pid)
        processB.kill()
    print("Done")

    return None
